#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <iostream>
#include <fcntl.h>

int main(int argc, char*argv[])
{
    pid_t pid;
    int ret, syn;
    int fd_pipe[2], fd_pipe_rev[2], fd;
    char buf1[] = "********************************************************\n";
    char buf2[] = "--------------------------------------------------------\n";

    if( pipe( fd_pipe ) != 0 )
    {
        perror( "pipe error" );
        return -1;
    }

    if( pipe( fd_pipe_rev ) != 0 )
    {
        perror( "pipe error" );
        return -1;
    }
    
    fd = open( "test.txt", O_CREAT | O_WRONLY, 0644 ); 

    pid = fork();
    if( pid < 0 )
    {
        perror( "fork error" );
    }
    else if( 0 == pid )
    {
        close( fd_pipe[0] );
        close( fd_pipe_rev[1] );
        pid = getpid();
        std::cout << "Komunikat z procesu potomnego: " << pid << std::endl;
        for( int i=0; i<1000; ++i )
        {
            read( fd_pipe_rev[0], &syn, sizeof( syn ) );
            write( fd, buf1, sizeof( buf1 ) ); 
            write( fd_pipe[1], &syn, sizeof( syn ) );
        }
        return 1;
    }
    else
    {
        close( fd_pipe[1] );
        close( fd_pipe_rev[0] );
        std::cout << "Komunikat z procesu macierzystego:" << getpid() << ", pid potomnego: " << pid << std::endl;
        
        write( fd_pipe_rev[1], &syn, sizeof( syn ) );
        for( int i=0; i<1000; ++i )
        {
            read( fd_pipe[0], &syn, sizeof( syn ) );
            write( fd, buf2, sizeof( buf2 ) );
            write( fd_pipe_rev[1], &syn, sizeof( syn ) );
        }

        std::cout << "Czekamy na proces potomny ... " << std::endl;        
        pid = wait( &ret );
        std::cout << "Zakonczyl sie proce potomny: " << pid << " z kodem " << ret << std::endl;
    }

    return 0;
}
